Team Roster in JavaScript

Using ApexCharts with JavaScript

This Team Roster example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// Per-unit data: every dot is ONE person, carrying its own name, role and
// (optionally) colour. The chart groups people by team; team leads get their
// own fillColor so a single dot stands out from its cluster. Hover any dot to
// read that individual's details, not the team aggregate. Shared by the
// vanilla-js, React and Vue builds.
var LEAD = '#FFAB00' // a lead's dot is tinted amber, overriding the team colour

var ROSTER = [
  {
    name: 'Engineering',
    data: [
      { name: 'Ana Ruiz', role: 'Engineering Lead', fillColor: LEAD },
      { name: 'Ben Cho', role: 'Staff Engineer' },
      { name: 'Priya Nair', role: 'Senior Engineer' },
      { name: 'Marco Silva', role: 'Senior Engineer' },
      { name: 'Yuki Tanaka', role: 'Engineer' },
      { name: 'Sam Okoye', role: 'Engineer' },
      { name: 'Lena Fischer', role: 'Engineer' },
      { name: 'Diego Torres', role: 'Engineer' },
      { name: 'Hana Kim', role: 'Junior Engineer' },
      { name: 'Omar Haddad', role: 'Junior Engineer' },
    ],
  },
  {
    name: 'Design',
    data: [
      { name: 'Noa Levi', role: 'Design Lead', fillColor: LEAD },
      { name: 'Tom Beck', role: 'Senior Designer' },
      { name: 'Ivy Chen', role: 'Product Designer' },
      { name: 'Kofi Mensah', role: 'Product Designer' },
      { name: 'Sara Nowak', role: 'Designer' },
      { name: 'Leo Rossi', role: 'Designer' },
    ],
  },
  {
    name: 'Sales',
    data: [
      { name: 'Mara Vidal', role: 'Sales Lead', fillColor: LEAD },
      { name: 'Jon Park', role: 'Account Executive' },
      { name: 'Ella Brandt', role: 'Account Executive' },
      { name: 'Raj Mehta', role: 'Account Executive' },
      { name: 'Fay Duval', role: 'SDR' },
      { name: 'Cole Ward', role: 'SDR' },
      { name: 'Nia Abara', role: 'SDR' },
      { name: 'Theo Blanc', role: 'SDR' },
    ],
  },
]

// Return the tooltip body for one hovered person: name on top, role beneath.
function rosterTooltip(o) {
  if (!o.datum) return o.seriesName
  return (
    '<div style="font-weight:700">' +
    o.datum.name +
    '</div>' +
    '<div style="opacity:0.7">' +
    o.datum.role +
    '</div>'
  )
}

var options = {
  series: ROSTER,
  chart: {
    type: 'unit',
    height: 440,
    animations: {
      enabled: true,
      speed: 700,
    },
  },
  colors: ['#008FFB', '#00B8D9', '#36B37E'],
  legend: {
    show: false,
  },
  plotOptions: {
    unit: {
      layout: 'grouped',
      spacing: 1.2,
      clusterLabels: {
        show: true,
        // Team name + headcount, e.g. "Engineering (10)".
        formatter: function (name, opts) {
          return name + ' (' + opts.value + ')'
        },
      },
      tooltip: {
        // rosterTooltip lives in the shared head script.
        formatter: rosterTooltip,
      },
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

// Nothing extra to wire: the chart renders from the options above. ROSTER and
// rosterTooltip live in the shared head script.

Team Roster in Angular

Using ApexCharts with Angular

This Team Roster example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private LEAD: any = '#FFAB00';

  private ROSTER: any = [
          {
            name: 'Engineering',
            data: [
              { name: 'Ana Ruiz', role: 'Engineering Lead', fillColor: this.LEAD },
              { name: 'Ben Cho', role: 'Staff Engineer' },
              { name: 'Priya Nair', role: 'Senior Engineer' },
              { name: 'Marco Silva', role: 'Senior Engineer' },
              { name: 'Yuki Tanaka', role: 'Engineer' },
              { name: 'Sam Okoye', role: 'Engineer' },
              { name: 'Lena Fischer', role: 'Engineer' },
              { name: 'Diego Torres', role: 'Engineer' },
              { name: 'Hana Kim', role: 'Junior Engineer' },
              { name: 'Omar Haddad', role: 'Junior Engineer' },
            ],
          },
          {
            name: 'Design',
            data: [
              { name: 'Noa Levi', role: 'Design Lead', fillColor: this.LEAD },
              { name: 'Tom Beck', role: 'Senior Designer' },
              { name: 'Ivy Chen', role: 'Product Designer' },
              { name: 'Kofi Mensah', role: 'Product Designer' },
              { name: 'Sara Nowak', role: 'Designer' },
              { name: 'Leo Rossi', role: 'Designer' },
            ],
          },
          {
            name: 'Sales',
            data: [
              { name: 'Mara Vidal', role: 'Sales Lead', fillColor: this.LEAD },
              { name: 'Jon Park', role: 'Account Executive' },
              { name: 'Ella Brandt', role: 'Account Executive' },
              { name: 'Raj Mehta', role: 'Account Executive' },
              { name: 'Fay Duval', role: 'SDR' },
              { name: 'Cole Ward', role: 'SDR' },
              { name: 'Nia Abara', role: 'SDR' },
              { name: 'Theo Blanc', role: 'SDR' },
            ],
          },
        ];

  private rosterTooltip = (o: any): any => {
          if (!o.datum) return o.seriesName
          return (
            '<div style="font-weight:700">' +
            o.datum.name +
            '</div>' +
            '<div style="opacity:0.7">' +
            o.datum.role +
            '</div>'
          )
        };

  public chartOptions: Partial<ChartOptions> = {
          series: this.ROSTER,
          chart: {
            type: 'unit',
            height: 440,
            animations: {
              enabled: true,
              speed: 700,
            },
          },
          colors: ['#008FFB', '#00B8D9', '#36B37E'],
          legend: {
            show: false,
          },
          plotOptions: {
            unit: {
              layout: 'grouped',
              spacing: 1.2,
              clusterLabels: {
                show: true,
                // Team name + headcount, e.g. "Engineering (10)".
                formatter: (name, opts) => {
                  return name + ' (' + opts.value + ')'
                },
              },
              tooltip: {
                // rosterTooltip lives in the shared head script.
                formatter: this.rosterTooltip,
              },
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Team Roster in Vue

Using ApexCharts with Vue

This Team Roster example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div class="wrap">
      <h1>Team roster</h1>
      <p>One dot per person, grouped by team, each carrying its own data.</p>

      <div class="chart-wrap">
        <div id="chart">
          <apexchart
            type="unit"
            height="440"
            :options="chartOptions"
            :series="series"
          ></apexchart>
        </div>
        <div class="legend-note">
          <span
            ><span class="swatch" style="background: #008ffb"></span
            >Engineering</span
          >
          <span
            ><span class="swatch" style="background: #00b8d9"></span
            >Design</span
          >
          <span
            ><span class="swatch" style="background: #36b37e"></span>Sales</span
          >
          <span
            ><span class="swatch" style="background: #ffab00"></span>Team
            lead</span
          >
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

// Per-unit data: every dot is ONE person, carrying its own name, role and
// (optionally) colour. The chart groups people by team; team leads get their
// own fillColor so a single dot stands out from its cluster. Hover any dot to
// read that individual's details, not the team aggregate. Shared by the
// vanilla-js, React and Vue builds.
var LEAD = '#FFAB00' // a lead's dot is tinted amber, overriding the team colour

var ROSTER = [
  {
    name: 'Engineering',
    data: [
      { name: 'Ana Ruiz', role: 'Engineering Lead', fillColor: LEAD },
      { name: 'Ben Cho', role: 'Staff Engineer' },
      { name: 'Priya Nair', role: 'Senior Engineer' },
      { name: 'Marco Silva', role: 'Senior Engineer' },
      { name: 'Yuki Tanaka', role: 'Engineer' },
      { name: 'Sam Okoye', role: 'Engineer' },
      { name: 'Lena Fischer', role: 'Engineer' },
      { name: 'Diego Torres', role: 'Engineer' },
      { name: 'Hana Kim', role: 'Junior Engineer' },
      { name: 'Omar Haddad', role: 'Junior Engineer' },
    ],
  },
  {
    name: 'Design',
    data: [
      { name: 'Noa Levi', role: 'Design Lead', fillColor: LEAD },
      { name: 'Tom Beck', role: 'Senior Designer' },
      { name: 'Ivy Chen', role: 'Product Designer' },
      { name: 'Kofi Mensah', role: 'Product Designer' },
      { name: 'Sara Nowak', role: 'Designer' },
      { name: 'Leo Rossi', role: 'Designer' },
    ],
  },
  {
    name: 'Sales',
    data: [
      { name: 'Mara Vidal', role: 'Sales Lead', fillColor: LEAD },
      { name: 'Jon Park', role: 'Account Executive' },
      { name: 'Ella Brandt', role: 'Account Executive' },
      { name: 'Raj Mehta', role: 'Account Executive' },
      { name: 'Fay Duval', role: 'SDR' },
      { name: 'Cole Ward', role: 'SDR' },
      { name: 'Nia Abara', role: 'SDR' },
      { name: 'Theo Blanc', role: 'SDR' },
    ],
  },
]

// Return the tooltip body for one hovered person: name on top, role beneath.
function rosterTooltip(o) {
  if (!o.datum) return o.seriesName
  return (
    '<div style="font-weight:700">' +
    o.datum.name +
    '</div>' +
    '<div style="opacity:0.7">' +
    o.datum.role +
    '</div>'
  )
}

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: ROSTER,
      chartOptions: {
        chart: {
          type: 'unit',
          height: 440,
          animations: {
            enabled: true,
            speed: 700,
          },
        },
        colors: ['#008FFB', '#00B8D9', '#36B37E'],
        legend: {
          show: false,
        },
        plotOptions: {
          unit: {
            layout: 'grouped',
            spacing: 1.2,
            clusterLabels: {
              show: true,
              // Team name + headcount, e.g. "Engineering (10)".
              formatter: function (name, opts) {
                return name + ' (' + opts.value + ')'
              },
            },
            tooltip: {
              // rosterTooltip lives in the shared head script.
              formatter: rosterTooltip,
            },
          },
        },
      },
    }
  },
  // Nothing extra to wire: the chart renders from the options above. ROSTER and
  // rosterTooltip live in the shared head script.,
}
</script>

<style>
body {
  font-family:
    -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, sans-serif;
  background: #fafbfc;
  color: #2c3e50;
  margin: 0;
  padding: 32px 16px;
}
.wrap {
  max-width: 760px;
  margin: 0 auto;
}
h1 {
  font-size: 22px;
  margin: 0 0 8px;
}
p {
  color: #5b6b78;
  line-height: 1.55;
  margin: 0 0 20px;
}
.chart-wrap {
  background: #fff;
  border-radius: 8px;
  padding: 16px;
  box-shadow: 0 2px 10px rgba(0, 0, 0, 0.04);
}
.legend-note {
  display: flex;
  gap: 18px;
  justify-content: center;
  margin-top: 14px;
  font-size: 13px;
  color: #5b6b78;
}
.legend-note .swatch {
  display: inline-block;
  width: 11px;
  height: 11px;
  border-radius: 50%;
  margin-right: 6px;
  vertical-align: middle;
}
</style>

Team Roster in React

Using ApexCharts with React

This Team Roster example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

// Per-unit data: every dot is ONE person, carrying its own name, role and
// (optionally) colour. The chart groups people by team; team leads get their
// own fillColor so a single dot stands out from its cluster. Hover any dot to
// read that individual's details, not the team aggregate. Shared by the
// vanilla-js, React and Vue builds.
var LEAD = '#FFAB00' // a lead's dot is tinted amber, overriding the team colour

var ROSTER = [
  {
    name: 'Engineering',
    data: [
      { name: 'Ana Ruiz', role: 'Engineering Lead', fillColor: LEAD },
      { name: 'Ben Cho', role: 'Staff Engineer' },
      { name: 'Priya Nair', role: 'Senior Engineer' },
      { name: 'Marco Silva', role: 'Senior Engineer' },
      { name: 'Yuki Tanaka', role: 'Engineer' },
      { name: 'Sam Okoye', role: 'Engineer' },
      { name: 'Lena Fischer', role: 'Engineer' },
      { name: 'Diego Torres', role: 'Engineer' },
      { name: 'Hana Kim', role: 'Junior Engineer' },
      { name: 'Omar Haddad', role: 'Junior Engineer' },
    ],
  },
  {
    name: 'Design',
    data: [
      { name: 'Noa Levi', role: 'Design Lead', fillColor: LEAD },
      { name: 'Tom Beck', role: 'Senior Designer' },
      { name: 'Ivy Chen', role: 'Product Designer' },
      { name: 'Kofi Mensah', role: 'Product Designer' },
      { name: 'Sara Nowak', role: 'Designer' },
      { name: 'Leo Rossi', role: 'Designer' },
    ],
  },
  {
    name: 'Sales',
    data: [
      { name: 'Mara Vidal', role: 'Sales Lead', fillColor: LEAD },
      { name: 'Jon Park', role: 'Account Executive' },
      { name: 'Ella Brandt', role: 'Account Executive' },
      { name: 'Raj Mehta', role: 'Account Executive' },
      { name: 'Fay Duval', role: 'SDR' },
      { name: 'Cole Ward', role: 'SDR' },
      { name: 'Nia Abara', role: 'SDR' },
      { name: 'Theo Blanc', role: 'SDR' },
    ],
  },
]

// Return the tooltip body for one hovered person: name on top, role beneath.
function rosterTooltip(o) {
  if (!o.datum) return o.seriesName
  return (
    '<div style="font-weight:700">' +
    o.datum.name +
    '</div>' +
    '<div style="opacity:0.7">' +
    o.datum.role +
    '</div>'
  )
}

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: ROSTER,
    options: {
      chart: {
        type: 'unit',
        height: 440,
        animations: {
          enabled: true,
          speed: 700,
        },
      },
      colors: ['#008FFB', '#00B8D9', '#36B37E'],
      legend: {
        show: false,
      },
      plotOptions: {
        unit: {
          layout: 'grouped',
          spacing: 1.2,
          clusterLabels: {
            show: true,
            // Team name + headcount, e.g. "Engineering (10)".
            formatter: function (name, opts) {
              return name + ' (' + opts.value + ')'
            },
          },
          tooltip: {
            // rosterTooltip lives in the shared head script.
            formatter: rosterTooltip,
          },
        },
      },
    },
  })

  // Nothing extra to wire: the chart renders from the options above. ROSTER and
  // rosterTooltip live in the shared head script.

  return (
    <div>
      <div className="wrap">
        <h1>Team roster</h1>
        <p>One dot per person, grouped by team, each carrying its own data.</p>

        <div className="chart-wrap">
          <div id="chart">
            <ReactApexChart
              options={state.options}
              series={state.series}
              type="unit"
              height={440}
            />
          </div>
          <div className="legend-note">
            <span>
              <span className="swatch" style="background:#008FFB"></span>
              Engineering
            </span>
            <span>
              <span className="swatch" style="background:#00B8D9"></span>Design
            </span>
            <span>
              <span className="swatch" style="background:#36B37E"></span>Sales
            </span>
            <span>
              <span className="swatch" style="background:#FFAB00"></span>Team
              lead
            </span>
          </div>
        </div>
      </div>
    </div>
  )
}

export default ApexChart